<template>
    <div class="tabComponentOptions" v-if="tabComponentOptions.length">
        <el-button
            v-for="tabComponent in tabComponentOptions"
            @click="handleSubPageClick(tabComponent, true)"
            :key="tabComponent.id"
            :class="`sub-comp-button ${
                currentTabComponent == tabComponent.alias ? 'active' : ''
            }`"
            >{{ tabComponent.name }}</el-button
        >
        <template v-for="tabComponent in tabComponentOptions">
            <div
                class="component-box"
                :key="tabComponent.alias"
                v-if="currentTabComponent == tabComponent.alias"
            >
                <component v-bind:is="currentTabComponent"></component>
            </div>
        </template>
    </div>
</template>

<script>
import menuApi from '@/api/menu.js'
import moduleRouter from '@/module_components.js'
export default {
    components: {
        ...moduleRouter,
    },
    data() {
        return {
            tabComponentOptions: [],
            currentTabComponent: '',
        }
    },
    mounted() {
        // this.$bus.$on('changeTab', (data) => {
        //     sessionStorage.setItem('changeTab', JSON.stringify(data))
        //     this.handleSubPageClick({alias: data.to}, false)
        // })
    },
    watch: {
        // 监听路由
        $route: {
            handler(to, from) {
                console.log(this.$route.path)
                console.log('去往：' , to)
                this.getMenus(this.$route.path)
            },
            immediate: true,
        },
    },
    methods: {
        getMenus(path) {
            let routePath = path
            if (routePath) {
                let path = routePath.split('/')
                routePath = path[path.indexOf('frontPlat') + 1]
            }
            console.log(routePath, "routePath")
            menuApi.getFrontMenuByAliasSub(routePath, (m) => {
                if (m) {
                    if (m.children && m.children.length > 0) {
                        this.tabComponentOptions = m.children
                        this.currentTabComponent =
                            m.activeTab || this.tabComponentOptions[0].alias
                        this.$forceUpdate()
                    } else {
                        this.tabComponentOptions = []
                        this.currentTabComponent = m.alias
                    }
                } else {
                    console.log('没有菜单的路由跳转')
                    // 没有菜单的路由跳转   需要显示TAb名称需要定义tobName参数传递过来
                    this.tabComponentOptions = []
                    this.currentTabComponent = ''
                }
            })
        },
        handleSubPageClick(data, clear) {
            if (data.alias) {
                this.currentTabComponent = data.alias
                if (clear) {
                    sessionStorage.removeItem('changeTab')
                }
            }
        },
        activeTab(fullpath) {
            console.log(fullpath, 'activeTab')
            let lastIdx = fullpath.lastIndexOf('#')
            console.log(lastIdx, 'lastIdx')
            if (lastIdx != -1) {
                let urlAnchor = fullpath.substr(lastIdx + 1)
                this.tabComponentOptions.filter((item) => {
                    if (item.alias == urlAnchor) {
                        this.currentTabComponent = urlAnchor
                        console.log(
                            this.currentTabComponent,
                            'this.currentTabComponent'
                        )
                    }
                })
            }
        },
    },
    // beforeRouteEnter(to, from, next) {
    //     // sessionStorage.removeItem('changeTab')
    //     next((vm) => {
    //         // 通过 `vm` 访问组件实例
    //         let routePath = vm.$route.path
    //         vm.getMenus(routePath)
    //         return
    //         // let activePlat
    //         // if (routePath) {
    //         //     let path = routePath.split('/')
    //         //     routePath = path[path.indexOf('frontPlat') + 1]

    //         //     if (vm.$route.path.indexOf('frontPlat') !== -1) {
    //         //         activePlat = 'getFrontMenuByAliasSub'
    //         //     } else {
    //         //         activePlat = 'getMenuByAlias'
    //         //     }
    //         // }
    //         // console.log(routePath, "routePath")
    //         // menuApi[activePlat](routePath, (m) => {
    //         //     if (m) {
    //         //         console.log(m, "m")
    //         //         vm.$emit('menuChange', m)
    //         //         if (m.children && m.children.length > 0) {
    //         //             vm.tabComponentOptions = m.children
    //         //             vm.currentTabComponent =
    //         //                 m.activeTab || vm.tabComponentOptions[0].alias
    //         //             vm.activeTab(to.fullPath)
    //         //         } else {
    //         //             vm.tabComponentOptions = []
    //         //             vm.currentTabComponent = m.alias
    //         //         }
    //         //     } else {
    //         //         console.log("没有菜单的路由跳转")
    //         //         // 没有菜单的路由跳转   需要显示TAb名称需要定义tobName参数传递过来
    //         //         vm.tabComponentOptions = []
    //         //         vm.currentTabComponent = to.name
    //         //         vm.$emit('menuChange', {
    //         //             name: to.params.tobName
    //         //                 ? to.params.tobName
    //         //                 : to.meta.menuLabel,
    //         //         })
    //         //     }
    //         // })
    //     })
    // }
}
</script>

<style lang='scss' scoped>
@import '@/assets/css/element-variables.scss';
.tabComponentOptions {
    color: $--color-text;
}
.component-box {
    height: calc(100% - 40px);
    width: 100%;
    box-sizing: border-box;
    position: relative;
}
.sub-comp-button {
    margin-bottom: 10px;
    background: rgba($--light-border, 0.3);
    border: 0;
    color: $--color-text;
}
.sub-comp-button.active {
    background: $--light-border;
    color: $--color-text;
}
</style>